// generated by CommonLibrary.cmake, do not edit.

/**
 * @file include/servus/qt/version.h
 * Defines version macros and class for library ServusQt.
 */

#ifndef SERVUSQT_VERSION_H
#define SERVUSQT_VERSION_H

#include <servus/qt/api.h>
#include <string>

namespace servusqt
{
    /** The current major version. */
#   define SERVUSQT_VERSION_MAJOR 1

    /** The current minor version. */
#   define SERVUSQT_VERSION_MINOR 6

    /** The current patch level. */
#   define SERVUSQT_VERSION_PATCH 0

    /** The current SCM revision. */
#   define SERVUSQT_VERSION_REVISION 0x0

    /** The current binary interface. */
#   define SERVUSQT_VERSION_ABI 6ull

    /** The current major.minor.version as a string. */
#   define SERVUSQT_VERSION_STRING \
    "1.6.0"

    /** The current major.minor.version.revision as a string. */
#   define SERVUSQT_REV_STRING \
    "1.6.0.0x0"

/** True if the current version is newer than the given one. */
#   define SERVUSQT_VERSION_GT( MAJOR, MINOR, PATCH )       \
    ( (SERVUSQT_VERSION_MAJOR>MAJOR) ||                     \
      (SERVUSQT_VERSION_MAJOR==MAJOR && (SERVUSQT_VERSION_MINOR>MINOR || \
          (SERVUSQT_VERSION_MINOR==MINOR && SERVUSQT_VERSION_PATCH>PATCH))))

/** True if the current version is equal or newer to the given. */
#   define SERVUSQT_VERSION_GE( MAJOR, MINOR, PATCH )       \
    ( (SERVUSQT_VERSION_MAJOR>MAJOR) ||                     \
      (SERVUSQT_VERSION_MAJOR==MAJOR && (SERVUSQT_VERSION_MINOR>MINOR || \
          (SERVUSQT_VERSION_MINOR==MINOR && SERVUSQT_VERSION_PATCH>=PATCH))))

/** True if the current version is older than the given one. */
#   define SERVUSQT_VERSION_LT( MAJOR, MINOR, PATCH )       \
    ( (SERVUSQT_VERSION_MAJOR<MAJOR) ||                     \
      (SERVUSQT_VERSION_MAJOR==MAJOR && (SERVUSQT_VERSION_MINOR<MINOR || \
          (SERVUSQT_VERSION_MINOR==MINOR && SERVUSQT_VERSION_PATCH<PATCH))))

/** True if the current version is older or equal to the given. */
#   define SERVUSQT_VERSION_LE( MAJOR, MINOR, PATCH )       \
    ( (SERVUSQT_VERSION_MAJOR<MAJOR) ||                     \
      (SERVUSQT_VERSION_MAJOR==MAJOR && (SERVUSQT_VERSION_MINOR<MINOR || \
        (SERVUSQT_VERSION_MINOR==MINOR && SERVUSQT_VERSION_PATCH<=PATCH))))

/** Information about the current ServusQt version. */
class SERVUSQT_API Version
{
public:
    /** @return the current major version of ServusQt. */
    static int getMajor();

    /** @return the current minor version of ServusQt. */
    static int getMinor();

    /** @return the current patch level of ServusQt. */
    static int getPatch();

    /** @return the current ServusQt version (MM.mm.pp). */
    static std::string getString();

    /** @return the SCM revision. */
    static unsigned long long getRevision();

    /** @return the current binary interface version of ServusQt. */
    static int getABI();

    /** @return the current ServusQt version plus the git SHA hash (MM.mm.pp.rev). */
    static std::string getRevString();

    /**
     * Runtime check for ABI compatibility.
     *
     * Call from code using ServusQt. Will fail if the executable
     * was compiled against a version incompatible with the runtime version.
     *
     * @return true if the link-time and compile-time DSO are compatible.
     */
    static bool check()
    {
        return getMajor()==SERVUSQT_VERSION_MAJOR &&
               getMinor()==SERVUSQT_VERSION_MINOR;
    }

    /** @return JSON schema describing this object. */
    static std::string getSchema()
    {
        return R"(
                {
                  "title": "Version",
                  "type": "object",
                  "description": "Version information of the running application",
                  "properties": {
                    "major": { "type": "integer" },
                    "minor": { "type": "integer" },
                    "patch": { "type": "integer" },
                    "abi": { "type": "integer" },
                    "revision": { "type": "string" }
                  }
               }
               )";
    }

    /** @return JSON-encoded data for this object. */
    static std::string toJSON()
    {
        return R"(
               {
                 "major": 1,
                 "minor": 6,
                 "patch": 0,
                 "abi": 6,
                 "revision": "0"
               }
               )";
    }
};

}

#endif
